// dmg types test by VEN

#include <amxmodx>
#include <fakemeta_util>
//#include <hamsandwich>

#define DMG_ALL_POSSIBLE ((1<<31) - 1)

/* +/- means whether a defined dmg type corresponds to a client dmg type icon or not */

                          #define DMG_CRUSH         (1<<0)       /* a */  // Crushed by falling or moving object
                          #define DMG_BULLET        (1<<1)       /* b */  // Shot
                          #define DMG_SLASH         (1<<2)       /* c */  // Cut, clawed, stabbed
/* +ICON: HEAT */         #define DMG_BURN          (1<<3)       /* d */  // Heat burned
/* -ICON: GAS[MASK] */    #define DMG_FREEZE        (1<<4)       /* e */  // Frozen
                          #define DMG_FALL          (1<<5)       /* f */  // Fell too far
                          #define DMG_BLAST         (1<<6)       /* g */  // Explosive blast damage
                          #define DMG_CLUB          (1<<7)       /* h */  // Crowbar, punch, headbutt
/* -ICON: NUMBER_0 */     #define DMG_SHOCK         (1<<8)       /* i */  // Electric shock
                          #define DMG_SONIC         (1<<9)       /* j */  // Sound pulse shockwave
                          #define DMG_ENERGYBEAM    (1<<10)      /* k */  // Laser or other high energy beam 
                          #define DMG_CUSTOM        (1<<11)      /* l */  // !!!CUSTOM ONE [missed from HLSDK]
			  #define DMG_NEVERGIB      (1<<12)      /* m */  // With this bit OR'd in, no damage type will be able to gib victims upon death
                          #define DMG_ALWAYSGIB     (1<<13)      /* n */  // With this bit OR'd in, any damage type can be made to gib victims upon death.
/* -ICON: COLD[FROZE] */  #define DMG_DROWN         (1<<14)      /* o */  // Drowning
                          #define DMG_PARALYZE      (1<<15)      /* p */  // Slows affected creature down
/* -ICON: RAD[IATION] */  #define DMG_NERVEGAS      (1<<16)      /* q */  // Nerve toxins, very bad
/* -ICON: CHEM[ICAL] */   #define DMG_POISON        (1<<17)      /* r */  // Blood poisioning
/* -ICON: [ELEC]SHOCK */  #define DMG_RADIATION     (1<<18)      /* s */  // Radiation exposure
                          #define DMG_DROWNRECOVER  (1<<19)      /* t */  // Drowning recovery
/* -ICON: DROWN[O2] */    #define DMG_ACID          (1<<20)      /* u */  // Toxic chemicals or acid burns
/* -ICON: [slow?]HEAT */  #define DMG_SLOWBURN      (1<<21)      /* v */  // In an oven
/* -ICON: GAS[MASK] */    #define DMG_SLOWFREEZE    (1<<22)      /* w */  // In a subzero freezer
                          #define DMG_MORTAR        (1<<23)      /* x */  // Hit by air raid (done to distinguish grenade from mortar)
                          #define DMG_TIMEBASED     (~(0x3fff))           // Mask for time-based damage


public plugin_init() {
	register_clcmd("say", "func") // for example: say d -- for heat burning dmg
}

public func(id) {
	new sztype[32]
	read_argv(1, sztype, 31)
	new type = read_flags(sztype)
	if (!type)
		type = DMG_ALL_POSSIBLE

	fm_fakedamage(id, "gaben", 1.0, type)
//	hs_takedamage(id, id, id, 1.0, type)

	return PLUGIN_CONTINUE
}

/* Recieved Damage dmg flags on DMG_ALL_POSSIBLE would be 7815448 i.e. a bit sum of flags that is listed below:

#define DMG_BURN                        (1<<3)      // Heat burned
#define DMG_FREEZE                      (1<<4)      // Frozen
#define DMG_SHOCK                       (1<<8)      // Electric shock
#define DMG_DROWN                       (1<<14)     // Drowning
#define DMG_NERVEGAS                    (1<<16)     // Nerve toxins, very bad
#define DMG_POISON                      (1<<17)     // Blood poisioning
#define DMG_RADIATION                   (1<<18)     // Radiation exposure
#define DMG_ACID                        (1<<20)     // Toxic chemicals or acid burns
#define DMG_SLOWBURN                    (1<<21)     // In an oven
#define DMG_SLOWFREEZE                  (1<<22)     // In a subzero freezer
*/
